%{
open Defs;; (* for the semantic actions, not for %type<.> ! *) 
%}

%token <int>    INT     /* int numbers */
%token <string> VAR     /* variables */
%token PLUS MINUS TIMES DIV
%token LPAREN RPAREN
%token SEMICOLON ASSIGN READ WRITE
%token BEGIN END 
%left PLUS MINUS        /* lowest precedence */
%left TIMES DIV         /* medium precedence */
%nonassoc UMINUS        /* highest precedence */
%start main             /* the entry point */
%type <Defs.program> main
%type <Defs.statement list> sequence
%type <Defs.statement> stmt
%type <Defs.expr> exp
%%
main:
  BEGIN sequence END         { Program (List.rev $2) }
  ;
sequence:
  stmt                       { [$1] }
| sequence SEMICOLON stmt    { $3 :: $1 }
    ;
stmt:
  VAR ASSIGN exp             { Assign ($1,$3) } 
| READ VAR                   { Read ($2) }
| WRITE exp                  { Write ($2) }
  ;
exp:
  INT                     { CInt $1 }
| VAR                     { Var  $1 } 
| LPAREN exp  RPAREN      { $2 }
| exp  PLUS exp           { Op ("+",[$1;$3]) }
| exp  MINUS exp          { Op ("-",[$1;$3]) }
| exp  TIMES exp          { Op ("*",[$1;$3]) }
| exp  DIV exp            { Op ("/",[$1;$3]) }
| MINUS exp %prec UMINUS  { Op ("-",[$2])    }
    ;
  
